"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.inputBodyPatchSchema = void 0;
const tslib_1 = require("tslib");
const _1 = require("./");
function inputBodyPatchSchema(entity, fieldsArray, relationsField, schemaName, arrayPropsConfig) {
    const json = (0, _1.inputBodyPostSchema)(entity, fieldsArray, relationsField, schemaName, arrayPropsConfig);
    const patternObject = {};
    patternObject.pattern = '^\\d+$';
    patternObject.description = 'Use string should be as number string';
    if (arrayPropsConfig.uuidProps.id) {
        patternObject.pattern =
            '^[0-9a-fA-F]{8}-[0-9a-fA-F]{4}-4[0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}$';
        patternObject.maxLength = 36;
        patternObject.minLength = 36;
        patternObject.description = 'Use string should be as uuid string';
    }
    json.properties.data.properties = Object.assign({
        id: Object.assign({ type: 'string' }, patternObject),
    }, json.properties.data.properties);
    json.properties.data.required.push('id');
    json.properties.data.properties.relationships.properties = Object.assign(Object.assign({}, json.properties.data.properties.relationships.properties), Object.keys(json.properties.data.properties.relationships.properties).reduce((acum, key) => {
        const data = json.properties.data.properties.relationships.properties[key].properties
            .data;
        const propertiesData = {
            data: {},
        };
        if (data.type === 'array') {
            const { minItems } = data, otherProps = tslib_1.__rest(data, ["minItems"]);
            propertiesData.data = otherProps;
        }
        else {
            propertiesData.data = {
                oneOf: [{ type: 'null' }, data],
            };
        }
        acum[key] = Object.assign(Object.assign({}, json.properties.data.properties.relationships.properties[key]), {
            properties: Object.assign(Object.assign({}, json.properties.data.properties.relationships.properties[key]
                .properties), propertiesData),
        });
        return acum;
    }, {}));
    return json;
}
exports.inputBodyPatchSchema = inputBodyPatchSchema;
//# sourceMappingURL=input-body-patch-schema.js.map